#!/usr/bin/perl -- -*-perl-*-

# ------------------------------------------------------------
# start_bj.pl, by Kyle Hourihan

# NOTE:  Check the variables below the splits() for server specific paths 


# Get the input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);

    # Un-Webify plus signs and %-encoding
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    # Stop people from using subshells to execute commands
    # Not a big deal when using sendmail, but very important
    # when using UCB mail (aka mailx).
    # $value =~ s/~!/ ~!/g; 
    # Uncomment for debugging purposes
    # print "Setting $name to $value<P>";

    $FORM{$name} = $value;
}



# ------------------------------------------------------------
# subroutine blank_response
sub blank_response
{
    print "Content-type: text/html\n\n";
    print "<TITLE> Incomplete Game Card </TITLE>";
    print "<H3> Incomplete Game Card </H3>";
    print "Your game card appears to be incomplete, and thus you ";
    print "need to complete it!  Please fix your problem.";
    print "return to our <A HREF=\"/\">home page</A>, if you want.<P>";
    exit;
}

# Print out a Server Redirect to URL constructed by the
# Blackjack Stylus Form

# Variable we set
$executable	= "playbj.cgi";
$options 	= "XYZW";
$seqnum		= 0;
$deck		= 0;
srand(time|$$);
$randomizer	= int(rand(1000000)+1);

# Variable the user set from the form
$game_type	= $FORM{'game_type'};
$balance	= $FORM{balance};
$num_decks	= $FORM{num_decks};
$num_players	= $FORM{num_players};
$bet		= $FORM{bet};

if ($bet > $balance) {
    $bet = $balance;
    }
	
# If the comments are blank, then give a "blank form" response
# No user checking YET!
&blank_response unless $game_type && $balance && $num_decks && num_players;


#
#  <options> <seq #> <deck> <random #> <bet> <balance> 
# 	[ <dealer_up_card> <HAND> [<HAND>]]


#print "Content-Type: text/html\n\n";
print "Location: $executable?$options\@$seqnum\@$deck\@$randomizer\@$bet\@$balance \n\n";

# Just the basic call...
#print "Location: $executable\n\n";


# If the comments are blank, then give a "blank form" response
# No user checking YET!
# &blank_response unless $FORM{'comments'} && ;
